#include <stdio.h>
#include <string.h>
#include <stdlib.h>    
#include "https.h"
#include "CH395_interface_operation.h"  
#include "delay.h"
#include "ch395.h" 
#include "html.h"

uint8_t i;
uint16_t len;
 
 extern struct   _SOCK_INF sockinf[4]; 
 extern uint8_t  flag;	
 extern uint8_t Http_SocketRecvBuf[3][1024]; 
 extern uint8_t discsocket_flag;
 char     tempURI[MAX_URI_SIZE]; 
 extern char  homepage_default[],test[];

 extern st_http_request *http_request;  
 char   *ptr1,*name,*ptemp;

/*********************WEBϬӦ±¨΄***************************************/
uint8_t  httpweb[200] ; 

/*********************************************************************************
* Function Name  : TempratureRefresh
* Description    : 
* Input          : 
* Output         : None
* Return         : None
*********************************************************************************/
void RefreshWebInfo(uint8_t *buf,char *name, uint32_t temp)
{
   uint8_t s[4],i;
   char *p = NULL;
   sprintf((char *)s,"%d",temp); 
    
   p = DataLocate((char *)buf, name);
    p++;
    p++;
    p++;
   
   for(i=0;i<4;i++)
   {
		 printf("i=%d \r\n",i);
    *p++=s[i];
   }
	 printf("RefreshWebInfo 2 \r\n");
}


/*********************************************************************************
* Function Name  : MakeHttpResponse
* Description    : 
* Input          :
* Output         : None
* Return         : None
*********************************************************************************/
uint8_t MakeHttpResponse(unsigned char * buf,char type)
{
  char * head=0;
  char tmp[10];
  uint16_t len; 
	
  if   (type == PTYPE_HTML)        head = RES_HTMLHEAD_OK;
  else if (type == PTYPE_GIF)      head = RES_GIFHEAD_OK;
  else if (type == PTYPE_TEXT)     head = RES_TEXTHEAD_OK;
  else if (type == PTYPE_JPEG)     head = RES_JPEGHEAD_OK;
  else if (type == PTYPE_FLASH)    head = RES_FLASHHEAD_OK;
  else if (type == PTYPE_MPEG)     head = RES_MPEGHEAD_OK;
  else if (type == PTYPE_PDF)      head = RES_PDFHEAD_OK;
  else if (type == PTYPE_CGI)      head = RETURN_CGI_PAGE;
   
  len = sizeof(HtmlBuffer);
 
  sprintf(tmp,"%d", len);  
  strcpy((char*)buf, head);
  strcat((char*)buf, tmp);
  strcat((char*)buf, "\r\n\r\n");
}

 /*********************************************************************************
* Function Name  : ParseUriType
* Description    : 
* Input          : 
* Output         : None
* Return         : None
*********************************************************************************/
void ParseUriType(uint8_t * type,char * buf ) 
{
  if    (strstr(buf, ".htm"))                             *type = PTYPE_HTML;
  else if (strstr(buf, ".gif"))                           *type = PTYPE_GIF;
  else if (strstr(buf, ".text") || strstr(buf,".txt"))    *type = PTYPE_TEXT;
  else if (strstr(buf, ".jpeg") || strstr(buf,".jpg"))    *type = PTYPE_JPEG;
  else if (strstr(buf, ".swf"))                           *type = PTYPE_FLASH;
  else if (strstr(buf, ".mpeg") || strstr(buf,".mpg"))    *type = PTYPE_MPEG;
  else if (strstr(buf, ".pdf"))                           *type = PTYPE_PDF;
  else if (strstr(buf, ".cgi") || strstr(buf,".CGI"))     *type = PTYPE_CGI;
  else if (strstr(buf, ".js")  || strstr(buf,".JS"))      *type = PTYPE_TEXT;  
  else if (strstr(buf, ".xml") || strstr(buf,".XML"))     *type = PTYPE_HTML;    
  else                                                    *type = PTYPE_ERR;
}

 /*********************************************************************************
* Function Name  : ParseHttpRequest
* Description    : 
* Input          : 
* Output         : None
* Return         : None
*********************************************************************************/
void ParseHttpRequest(st_http_request * request,char * buf)
{
  char * nexttok;
	
  nexttok = strtok(buf," ");
  if(!nexttok)
  {
    request->METHOD = METHOD_ERR;
    return;
  }
  if(!strcmp(nexttok, "GET") || !strcmp(nexttok,"get"))
  {
    request->METHOD = METHOD_GET;
    nexttok = strtok(NULL," ");  		   
  }
  else if(!strcmp(nexttok, "HEAD") || !strcmp(nexttok,"head"))  
  {
    request->METHOD = METHOD_HEAD;
    nexttok = strtok(NULL," ");
    printf("METHOD = HEAD!\n");        
  }
  else if (!strcmp(nexttok, "POST") || !strcmp(nexttok,"post"))
  {  
    request->METHOD = METHOD_POST;
		nexttok = strtok(NULL,"\0");
    printf("METHOD = POST!\n");         
  }
  else
  {
    request->METHOD = METHOD_ERR;
    return;		
  }  
  strcpy((char*)request->URI,nexttok);
}

/*********************************************************************************
* Function Name  : DataLocate
* Description    : 
* Input          : 
* Output         : None
* Return         : None
*********************************************************************************/
char* DataLocate(char* buf,char* name)
{
   char* p;
   p = strstr((char *)buf,name);
   if (p==NULL) return NULL;
   p += strlen(name); 
   return p;
}

/*********************************************************************************
* Function Name  : GetUriName
* Description    : 
* Input          : URI
* Output         : None
* Return         : None
*********************************************************************************/
char* GetUriName(char* uri)
{
  char* uri_name;
	
  if(!uri) return 0;
  memset (tempURI, 0, MAX_URI_SIZE);  
  strcpy((char*)tempURI,uri);
  uri_name = tempURI;
  if(strcmp(uri_name,"/")) uri_name++;
  return uri_name;
}




/**********************************************************************************
* Function Name  : WebServer
* Description    : web·þαַ³̐򍊪 Input          : WebServer
* Output         : None
* Return         : None
*********************************************************************************/
void WebServer(uint8_t sockindex)
{
	uint32_t typef = 0;

	if(flag & RECVDATA)
	{
		flag  &= ~RECVDATA;
		ParseHttpRequest(http_request,(char *)Http_SocketRecvBuf);    
		switch (http_request->METHOD)  
		{
			case METHOD_ERR :  
			     break;
			case METHOD_HEAD:;
			case METHOD_POST:;
			case METHOD_GET:
				name = (char*)GetUriName((char *)http_request->URI);
				if (!strcmp(name, "/")) {http_request->TYPE = PTYPE_HTML;}
				else { ParseUriType(&http_request->TYPE, name);  }
     
				if(http_request->TYPE == PTYPE_CGI)
				{
					ptr1 =  strstr((char *)(http_request->URI),"ɨփ") ;                                
					if(ptr1 !=NULL)
					{
						printf("http_request->URI)\n");
						ptr1 = strstr((char *)(http_request->URI),"IP");                                                
						if (ptr1 !=NULL)
						{
							flag |= IPCHANGE;                                                                           
							printf("ip change\n");
						}
					}            

						ptr1 = strstr((char *)(http_request->URI),"PORT");                                               
						if (ptr1 !=NULL)
						{
								flag |= PORTCHANGE;                                                                         
						}
					}
					ptr1 = strstr((char *)(http_request->URI),"monitor"); 
					if(ptr1 !=NULL)
					{
					}
		}
    memset(httpweb,0,200);
    typef = MakeHttpResponse(httpweb,http_request->TYPE);
    ch395_send_data(http_sock,httpweb,strlen((char*)httpweb));                                              
    i = ch395_get_socket_int(http_sock);
		
       len = WEB_LEN;
			 sockinf[http_sock].RemLen = len;  
       if(len > 1024) len = 1024; 
       ch395_send_data(http_sock,(uint8_t *)HtmlBuffer,len); 
       sockinf[http_sock].SendLen = len;                                          
       sockinf[http_sock].pSend = (uint8_t *)HtmlBuffer; 
	}
	http_sock = 0;		
}

