#ifndef _mcu_com_if__
#define _mcu_com_if__

#include "delay.h" 

#ifndef uint8_t
typedef unsigned char uint8_t;
#endif

#ifndef uint16_t
typedef unsigned short uint16_t;
#endif

#ifndef uint32_t
typedef unsigned int uint32_t;
#endif

//#define ch395_scs_hign
//#define ch395_scs_low  

#define ch395_scs_hign (*(uint32_t*)(GPIOA_BASE+0x10))|=(1<<4)
#define ch395_scs_low  (*(uint32_t*)(GPIOA_BASE+0x14))|=(1<<4)


#define ch32_gpio_in_a (*(uint32_t*)(GPIOA_BASE+0x08))
#define ch395_exti_stat (ch32_gpio_in_a&0x0001)


void SPI_FullDuplex_Init(void);
void Control_IO_Init(void);
void CH395_SPI_Init(void);
void ch395_write_cmd( uint8_t mCmd );
void ch395_write_data( uint8_t mData );
uint8_t ch395_read_data( void );
void USART2_init(void);
void set_usart2_bandrate(uint32_t bandrate);
void SPI1_DMA_Tx_Init(DMA_Channel_TypeDef* DMA_CHx,uint32_t cpar,uint32_t cmar,u16 bufsize);
void SPI1_DMA_Rx_Init( DMA_Channel_TypeDef* DMA_CHx, uint32_t ppadr, uint32_t memadr, u16 bufsize );
void SPI_DMA_Read(u16 length);
uint8_t SPI1_ReadByte(uint8_t TxData);
void spi_data_write(uint8_t mData);
void control_UART_Init(void);
#endif
